var gulp = require('gulp');
var del = require('del');
var tsc = require('gulp-typescript');
var replace = require('gulp-replace-task');
var tsProject = tsc.createProject('tsconfig.json', {  typescript: require('typescript')
        , sortOutput: true });
var fs = require('fs');
var path = require('path');

//set path to directory where the config file is. (not the repo)
var environmentSettings = './configProperties.json';

gulp.task('build',['clean'],() => {
       
 
        gulp.src(['src/ts/**/*.ts', 'typings/**/*.d.ts'], { base: 'src/ts' })
               .pipe(replaceEnvironmentVars())
               .pipe(tsc(tsProject))
               .pipe(gulp.dest('src/dist'));
});

function replaceEnvironmentVars(){
            // Get the JSON settings.
            var jsonEnvSettings = JSON.parse(fs.readFileSync(path.join(__dirname, environmentSettings), 'utf8'));

            console.log('Set environment variables...',
                    jsonEnvSettings);  
            // Replace the placeholder @@dbConnection with the dbConnection from the json file.          
            return replace({
              patterns: [
                    {
                      json: jsonEnvSettings 
                    }
              ]
            });                        
};


//Throw away the old build
gulp.task('clean', () => {
  console.log('Clean old build');
  del(['src/dist']);
});

